﻿using System;
using System.Collections.Generic;

namespace SingletonExampleComparer
{
    class Program
    {
        static void Main()
        {
            List<Teacher> teachers = new List<Teacher>
            {
                new Teacher {Id = 1, Name = "Anders", Salary = 1000},
                new Teacher {Id = 2, Name = "John", Salary = 900},
                new Teacher {Id = 4, Name = "Dennis", Salary = 1200}
            };

            teachers.Sort();
            Console.WriteLine(String.Join(", ", teachers));

            teachers.Sort(TeacherNameComparer.Instance);
            Console.WriteLine(String.Join(", ", teachers));

            teachers.Sort(TeacherSalaryComparer.Instance);
            Console.WriteLine(String.Join(", ", teachers));
     
            teachers.Sort(TeacherSalaryComparer.Instance.Reverse());
            Console.WriteLine(String.Join(", ", teachers));

            teachers.Sort(Utils.Reverse2(TeacherSalaryComparer.Instance));
            Console.WriteLine(String.Join(", ", teachers));

        }
    }
}
