﻿using System;

namespace SingletonExampleComparer
{
    public class Teacher : IComparable<Teacher>
    {
        public int Id { get; set; }
        public String Name { get; set; }

        public double Salary { get; set; }

        public int CompareTo(Teacher other)
        {
            return this.Id - other.Id;
        }

        public override string ToString()
        {
            return string.Format("Id: {0}, Name: {1}, Salary: {2}", Id, Name, Salary);
        }
    }
}
